diff -urN sbcl-0.8.16/src/compiler/srctran.lisp sbcl-0.8.16.patched/src/compiler/srctran.lisp
--- sbcl-0.8.16/src/compiler/srctran.lisp	2004-08-16 21:51:28.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/srctran.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -2321,7 +2321,29 @@
         (specifier-type `(integer ,lo-res ,hi-res))))))
 
 (defoptimizer (code-char derive-type) ((code))
-  (specifier-type 'base-char))
+  (let ((type (lvar-type code)))
+    ;; FIXME: unions of integral ranges?  It ought to be easier to do
+    ;; this, given that CHARACTER-SET is basically an integral range
+    ;; type.  -- CSR, 2004-10-04
+    (when (numeric-type-p type)
+      (let* ((lo (numeric-type-low type))
+             (hi (numeric-type-high type))
+             (type (specifier-type `(character-set ((,lo . ,hi))))))
+        (cond
+          ;; KLUDGE: when running on the host, we lose a slight amount
+          ;; of precision so that we don't have to "unparse" types
+          ;; that formally we can't, such as (CHARACTER-SET ((0
+          ;; . 0))).  -- CSR, 2004-10-06
+          #+sb-xc-host
+          ((csubtypep type (specifier-type 'standard-char)) type)
+          #+sb-xc-host
+          ((csubtypep type (specifier-type 'base-char))
+           (specifier-type 'base-char))
+          #+sb-xc-host
+          ((csubtypep type (specifier-type 'extended-char))
+           (specifier-type 'extended-char))
+          (t #+sb-xc-host (specifier-type 'character)
+             #-sb-xc-host type))))))
 
 (defoptimizer (values derive-type) ((&rest values))
   (make-values-type :required (mapcar #'lvar-type values)))
@@ -2962,21 +2984,18 @@
 ;;; then the result is definitely false.
 (deftransform simple-equality-transform ((x y) * *
 					 :defun-only t)
-  (cond ((same-leaf-ref-p x y)
-	 t)
-	((not (types-equal-or-intersect (lvar-type x)
-					(lvar-type y)))
-	 nil)
-	(t
-	 (give-up-ir1-transform))))
+  (cond
+    ((same-leaf-ref-p x y) t)
+    ((not (types-equal-or-intersect (lvar-type x) (lvar-type y)))
+     nil)
+    (t (give-up-ir1-transform))))
 
 (macrolet ((def (x)
              `(%deftransform ',x '(function * *) #'simple-equality-transform)))
   (def eq)
-  (def char=)
-  (def equal))
+  (def char=))
 
-;;; This is similar to SIMPLE-EQUALITY-PREDICATE, except that we also
+;;; This is similar to SIMPLE-EQUALITY-TRANSFORM, except that we also
 ;;; try to convert to a type-specific predicate or EQ:
 ;;; -- If both args are characters, convert to CHAR=. This is better than
 ;;;    just converting to EQ, since CHAR= may have special compilation
@@ -2995,23 +3014,42 @@
 	(y-type (lvar-type y))
 	(char-type (specifier-type 'character))
 	(number-type (specifier-type 'number)))
-    (cond ((same-leaf-ref-p x y)
-	   t)
-	  ((not (types-equal-or-intersect x-type y-type))
-	   nil)
-	  ((and (csubtypep x-type char-type)
-		(csubtypep y-type char-type))
-	   '(char= x y))
-	  ((or (not (types-equal-or-intersect x-type number-type))
-	       (not (types-equal-or-intersect y-type number-type)))
-	   '(eq x y))
-	  ((and (not (constant-lvar-p y))
-		(or (constant-lvar-p x)
-		    (and (csubtypep x-type y-type)
-			 (not (csubtypep y-type x-type)))))
-	   '(eql y x))
-	  (t
-	   (give-up-ir1-transform)))))
+    (cond
+      ((same-leaf-ref-p x y) t)
+      ((not (types-equal-or-intersect x-type y-type))
+       nil)
+      ((and (csubtypep x-type char-type)
+	    (csubtypep y-type char-type))
+       '(char= x y))
+      ((or (not (types-equal-or-intersect x-type number-type))
+	   (not (types-equal-or-intersect y-type number-type)))
+       '(eq x y))
+      ((and (not (constant-lvar-p y))
+	    (or (constant-lvar-p x)
+		(and (csubtypep x-type y-type)
+		     (not (csubtypep y-type x-type)))))
+       '(eql y x))
+      (t
+       (give-up-ir1-transform)))))
+
+;;; similarly to the EQL transform above, we attempt to constant-fold
+;;; or convert to a simpler predicate: mostly we have to be careful
+;;; with strings.
+(deftransform equal ((x y) * *)
+  "convert to simpler equality predicate"
+  (let ((x-type (lvar-type x))
+	(y-type (lvar-type y))
+	(string-type (specifier-type 'string)))
+    (cond
+      ((same-leaf-ref-p x y) t)
+      ((and (csubtypep x-type string-type)
+	    (csubtypep y-type string-type))
+       '(string= x y))
+      ((and (or (not (types-equal-or-intersect x-type string-type))
+		(not (types-equal-or-intersect y-type string-type)))
+	    (not (types-equal-or-intersect x-type y-type)))
+       nil)
+      (t (give-up-ir1-transform)))))
 
 ;;; Convert to EQL if both args are rational and complexp is specified
 ;;; and the same for both.
diff -urN sbcl-0.8.16/src/compiler/target-dump.lisp sbcl-0.8.16.patched/src/compiler/target-dump.lisp
--- sbcl-0.8.16/src/compiler/target-dump.lisp	2004-09-08 20:17:37.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/target-dump.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -13,6 +13,21 @@
 
 (in-package "SB!FASL")
 
+;;; a helper function shared by DUMP-SIMPLE-CHARACTER-STRING and
+;;; DUMP-SYMBOL (in the target compiler: the cross-compiler uses the
+;;; portability knowledge and always dumps BASE-STRINGS).
+(defun dump-characters-of-string (s fasl-output)
+  (declare (type string s) (type fasl-output fasl-output))
+  (dovector (c s)
+    (dump-word (char-code c) fasl-output))
+  (values))
+
+(defun dump-simple-character-string (s file)
+  (declare (type (simple-array character (*)) s))
+  (dump-fop* (length s) fop-small-character-string fop-character-string file)
+  (dump-characters-of-string s file)
+  (values))
+
 ;;; Dump the first N bytes of VEC out to FILE. VEC is some sort of unboxed
 ;;; vector-like thing that we can BLT from.
 (defun dump-raw-bytes (vec n fasl-output)
diff -urN sbcl-0.8.16/src/compiler/typetran.lisp sbcl-0.8.16.patched/src/compiler/typetran.lisp
--- sbcl-0.8.16/src/compiler/typetran.lisp	2004-04-13 12:30:39.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/typetran.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -115,7 +115,6 @@
 ;;; just expand all its operations into toplevel code?
 (defun !define-standard-type-predicates ()
   (define-type-predicate arrayp array)
-  ; (The ATOM predicate is handled separately as (NOT CONS).)
   (define-type-predicate bit-vector-p bit-vector)
   (define-type-predicate characterp character)
   (define-type-predicate compiled-function-p compiled-function)
@@ -141,13 +140,11 @@
   (define-type-predicate symbolp symbol)
   (define-type-predicate vectorp vector))
 (!define-standard-type-predicates)
-
-;;;; transforms for type predicates not implemented primitively
-;;;;
-;;;; See also VM dependent transforms.
 
 (define-source-transform atom (x)
   `(not (consp ,x)))
+(define-source-transform base-char-p (x)
+  `(typep ,x 'base-char))
 
 ;;;; TYPEP source transform
 
@@ -292,6 +289,21 @@
 			`((typep (cdr ,n-obj)
 				 ',(type-specifier cdr-type))))))))))
  
+(defun source-transform-character-set-typep (object type)
+  (let ((pairs (character-set-type-pairs type)))
+    (if (and (= (length pairs) 1)
+	     (= (caar pairs) 0)
+	     (= (cdar pairs) (1- sb!xc:char-code-limit)))
+	`(characterp ,object)
+	(once-only ((n-obj object))
+	  (let ((n-code (gensym "CODE")))
+	    `(and (characterp ,n-obj)
+	          (let ((,n-code (sb!xc:char-code ,n-obj)))
+		    (or
+		     ,@(loop for pair in pairs
+			     collect
+			     `(<= ,(car pair) ,n-code ,(cdr pair)))))))))))
+
 ;;; Return the predicate and type from the most specific entry in
 ;;; *TYPE-PREDICATES* that is a supertype of TYPE.
 (defun find-supertype-predicate (type)
@@ -371,7 +383,7 @@
       ;; If not properly named, error.
       ((not (and name (eq (find-classoid name) class)))
        (compiler-error "can't compile TYPEP of anonymous or undefined ~
-			class:~%  ~S"
+                        class:~%  ~S"
 		       class))
       (t
         ;; Delay the type transform to give type propagation a chance.
@@ -493,6 +505,8 @@
 	       (source-transform-array-typep object type))
 	      (cons-type
 	       (source-transform-cons-typep object type))
+	      (character-set-type
+	       (source-transform-character-set-typep object type))
 	      (t nil))
 	    `(%typep ,object ,spec)))
       (values nil t)))
diff -urN sbcl-0.8.16/src/compiler/x86/array.lisp sbcl-0.8.16.patched/src/compiler/x86/array.lisp
--- sbcl-0.8.16/src/compiler/x86/array.lisp	2004-08-10 16:20:48.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/x86/array.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -1245,10 +1245,10 @@
   (:args (object :scs (descriptor-reg))
 	 (index :scs (unsigned-reg)))
   (:arg-types simple-base-string positive-fixnum)
-  (:results (value :scs (base-char-reg)))
-  (:result-types base-char)
+  (:results (value :scs (character-reg)))
+  (:result-types character)
   (:generator 5
-    (inst mov value
+    (inst movzx value
 	  (make-ea :byte :base object :index index :scale 1
 		   :disp (- (* vector-data-offset n-word-bytes)
 			    other-pointer-lowtag)))))
@@ -1259,10 +1259,10 @@
   (:args (object :scs (descriptor-reg)))
   (:info index)
   (:arg-types simple-base-string (:constant (signed-byte 30)))
-  (:results (value :scs (base-char-reg)))
-  (:result-types base-char)
+  (:results (value :scs (character-reg)))
+  (:result-types character)
   (:generator 4
-    (inst mov value
+    (inst movzx value
 	  (make-ea :byte :base object
 		   :disp (- (+ (* vector-data-offset n-word-bytes) index)
 			    other-pointer-lowtag)))))
@@ -1272,32 +1272,48 @@
   (:policy :fast-safe)
   (:args (object :scs (descriptor-reg) :to (:eval 0))
 	 (index :scs (unsigned-reg) :to (:eval 0))
-	 (value :scs (base-char-reg) :target result))
-  (:arg-types simple-base-string positive-fixnum base-char)
-  (:results (result :scs (base-char-reg)))
-  (:result-types base-char)
+	 (value :scs (character-reg) :target eax))
+  (:arg-types simple-base-string positive-fixnum character)
+  (:temporary (:sc character-reg :offset eax-offset :target result
+                   :from (:argument 2) :to (:result 0))
+              eax)
+  (:results (result :scs (character-reg)))
+  (:result-types character)
   (:generator 5
+    (move eax value)
     (inst mov (make-ea :byte :base object :index index :scale 1
 		       :disp (- (* vector-data-offset n-word-bytes)
 				other-pointer-lowtag))
-	  value)
-    (move result value)))
+	  al-tn)
+    (move result eax)))
 
-(define-vop (data-vector-set/simple-base-string-c)
+(define-vop (data-vector-set-c/simple-base-string)
   (:translate data-vector-set)
   (:policy :fast-safe)
   (:args (object :scs (descriptor-reg) :to (:eval 0))
-	 (value :scs (base-char-reg)))
+	 (value :scs (character-reg)))
   (:info index)
-  (:arg-types simple-base-string (:constant (signed-byte 30)) base-char)
-  (:results (result :scs (base-char-reg)))
-  (:result-types base-char)
+  (:arg-types simple-base-string (:constant (signed-byte 30)) character)
+  (:temporary (:sc unsigned-reg :offset eax-offset :target result
+                   :from (:argument 1) :to (:result 0))
+              eax)
+  (:results (result :scs (character-reg)))
+  (:result-types character)
   (:generator 4
-   (inst mov (make-ea :byte :base object
-		      :disp (- (+ (* vector-data-offset n-word-bytes) index)
-			       other-pointer-lowtag))
-	 value)
-   (move result value)))
+    (move eax value)
+    (inst mov (make-ea :byte :base object
+                       :disp (- (+ (* vector-data-offset n-word-bytes) index)
+                                other-pointer-lowtag))
+          al-tn)
+    (move result eax)))
+
+(define-full-reffer data-vector-ref/simple-character-string
+    simple-character-string vector-data-offset other-pointer-lowtag
+    (character-reg) character data-vector-ref)
+
+(define-full-setter data-vector-ref/simple-character-string
+    simple-character-string vector-data-offset other-pointer-lowtag
+    (character-reg) character data-vector-set)
 
 ;;; signed-byte-8
 
diff -urN sbcl-0.8.16/src/compiler/x86/c-call.lisp sbcl-0.8.16.patched/src/compiler/x86/c-call.lisp
--- sbcl-0.8.16/src/compiler/x86/c-call.lisp	2004-09-09 14:10:15.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/x86/c-call.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -185,7 +185,7 @@
   (:translate foreign-symbol-address)
   (:policy :fast-safe)
   (:args)
-  (:arg-types (:constant simple-base-string))
+  (:arg-types (:constant simple-string))
   (:info foreign-symbol)
   (:results (res :scs (sap-reg)))
   (:result-types system-area-pointer)
diff -urN sbcl-0.8.16/src/compiler/x86/cell.lisp sbcl-0.8.16.patched/src/compiler/x86/cell.lisp
--- sbcl-0.8.16/src/compiler/x86/cell.lisp	2003-05-08 18:17:59.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/x86/cell.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -46,7 +46,7 @@
 		     (make-ea :dword :base object
 			      :disp (- (* offset n-word-bytes) lowtag))
 		     (logior (ash (char-code val) n-widetag-bits)
-			     base-char-widetag)))))
+			     character-widetag)))))
        ;; Else, value not immediate.
        (storew value object offset lowtag))))
 
diff -urN sbcl-0.8.16/src/compiler/x86/char.lisp sbcl-0.8.16.patched/src/compiler/x86/char.lisp
--- sbcl-0.8.16/src/compiler/x86/char.lisp	2003-07-02 10:36:57.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/x86/char.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -14,110 +14,103 @@
 ;;;; moves and coercions
 
 ;;; Move a tagged char to an untagged representation.
-(define-vop (move-to-base-char)
-  (:args (x :scs (any-reg control-stack) :target al))
-  (:temporary (:sc byte-reg :offset al-offset
-		   :from (:argument 0) :to (:eval 0)) al)
-  (:ignore al)
-  (:temporary (:sc byte-reg :offset ah-offset :target y
-		   :from (:argument 0) :to (:result 0)) ah)
-  (:results (y :scs (base-char-reg base-char-stack)))
+(define-vop (move-to-character)
+  (:args (x :scs (any-reg descriptor-reg) :target y
+            :load-if (not (location= x y))))
+  (:results (y :scs (character-reg)
+               :load-if (not (location= x y))))
   (:note "character untagging")
   (:generator 1
-    (move eax-tn x)
-    (move y ah)))
-(define-move-vop move-to-base-char :move
-  (any-reg control-stack) (base-char-reg base-char-stack))
+    (move y x)
+    (inst shr y n-widetag-bits)))
+(define-move-vop move-to-character :move
+  (any-reg) (character-reg))
 
 ;;; Move an untagged char to a tagged representation.
-(define-vop (move-from-base-char)
-  (:args (x :scs (base-char-reg base-char-stack) :target ah))
-  (:temporary (:sc byte-reg :offset al-offset :target y
-		   :from (:argument 0) :to (:result 0)) al)
-  (:temporary (:sc byte-reg :offset ah-offset
-		   :from (:argument 0) :to (:result 0)) ah)
-  (:results (y :scs (any-reg descriptor-reg control-stack)))
+(define-vop (move-from-character)
+  (:args (x :scs (character-reg)))
+  (:results (y :scs (any-reg descriptor-reg)))
   (:note "character tagging")
   (:generator 1
-    (move ah x)				; Maybe move char byte.
-    (inst mov al base-char-widetag)	; x86 to type bits
-    (inst and eax-tn #xffff)		; Remove any junk bits.
-    (move y eax-tn)))
-(define-move-vop move-from-base-char :move
-  (base-char-reg base-char-stack) (any-reg descriptor-reg control-stack))
+    ;; FIXME: is this inefficient?  Is there a better way of writing
+    ;; it?  (fixnum tagging is done with LEA).  We can't use SHL
+    ;; because we either scribble over the source register or briefly
+    ;; have a non-descriptor in a descriptor register, unless we
+    ;; introduce a temporary.
+    (inst imul y x (ash 1 n-widetag-bits))
+    (inst or y character-widetag)))
+(define-move-vop move-from-character :move
+  (character-reg) (any-reg descriptor-reg))
 
-;;; Move untagged base-char values.
-(define-vop (base-char-move)
+;;; Move untagged character values.
+(define-vop (character-move)
   (:args (x :target y
-	    :scs (base-char-reg)
+	    :scs (character-reg)
 	    :load-if (not (location= x y))))
-  (:results (y :scs (base-char-reg base-char-stack)
+  (:results (y :scs (character-reg character-stack)
 	       :load-if (not (location= x y))))
   (:note "character move")
   (:effects)
   (:affected)
   (:generator 0
     (move y x)))
-(define-move-vop base-char-move :move
-  (base-char-reg) (base-char-reg base-char-stack))
+(define-move-vop character-move :move
+  (character-reg) (character-reg character-stack))
 
-;;; Move untagged base-char arguments/return-values.
-(define-vop (move-base-char-arg)
+;;; Move untagged character arguments/return-values.
+(define-vop (move-character-arg)
   (:args (x :target y
-	    :scs (base-char-reg))
+	    :scs (character-reg))
 	 (fp :scs (any-reg)
-	     :load-if (not (sc-is y base-char-reg))))
+	     :load-if (not (sc-is y character-reg))))
   (:results (y))
   (:note "character arg move")
   (:generator 0
     (sc-case y
-      (base-char-reg
+      (character-reg
        (move y x))
-      (base-char-stack
-       (inst mov
-	     (make-ea :byte :base fp :disp (- (* (1+ (tn-offset y)) 4)))
-	     x)))))
-(define-move-vop move-base-char-arg :move-arg
-  (any-reg base-char-reg) (base-char-reg))
+      (character-stack
+       ;; copied blindly.  No idea if it's right
+       (if (= (tn-offset fp) esp-offset)
+	   (storew x fp (tn-offset y))	; c-call
+	   (storew x fp (- (1+ (tn-offset y)))))))))
+(define-move-vop move-character-arg :move-arg
+  (any-reg character-reg) (character-reg))
 
-;;; Use standard MOVE-ARG + coercion to move an untagged base-char
+;;; Use standard MOVE-ARG + coercion to move an untagged character
 ;;; to a descriptor passing location.
 (define-move-vop move-arg :move-arg
-  (base-char-reg) (any-reg descriptor-reg))
+  (character-reg) (any-reg descriptor-reg))
 
 ;;;; other operations
 
 (define-vop (char-code)
   (:translate char-code)
   (:policy :fast-safe)
-  (:args (ch :scs (base-char-reg base-char-stack)))
-  (:arg-types base-char)
+  (:args (ch :scs (character-reg character-stack)))
+  (:arg-types character)
   (:results (res :scs (unsigned-reg)))
   (:result-types positive-fixnum)
   (:generator 1
-    (inst movzx res ch)))
+    (inst mov res ch)))
 
 (define-vop (code-char)
   (:translate code-char)
   (:policy :fast-safe)
-  (:args (code :scs (unsigned-reg unsigned-stack) :target eax))
+  (:args (code :scs (unsigned-reg unsigned-stack)))
   (:arg-types positive-fixnum)
-  (:temporary (:sc unsigned-reg :offset eax-offset :target res
-		   :from (:argument 0) :to (:result 0))
-	      eax)
-  (:results (res :scs (base-char-reg)))
-  (:result-types base-char)
+  (:results (res :scs (character-reg)))
+  (:result-types character)
   (:generator 1
-    (move eax code)
-    (move res al-tn)))
+    (inst mov res code)))
 
-;;; comparison of BASE-CHARs
-(define-vop (base-char-compare)
-  (:args (x :scs (base-char-reg base-char-stack))
-	 (y :scs (base-char-reg)
-	    :load-if (not (and (sc-is x base-char-reg)
-			       (sc-is y base-char-stack)))))
-  (:arg-types base-char base-char)
+;;; comparison of CHARACTERs
+(define-vop (character-compare)
+  (:args (x :scs (character-reg character-stack))
+	 (y :scs (character-reg)
+	    :load-if (not (and (sc-is x character-reg)
+			       (sc-is y character-stack)))))
+  (:arg-types character character)
   (:conditional)
   (:info target not-p)
   (:policy :fast-safe)
@@ -127,21 +120,21 @@
     (inst cmp x y)
     (inst jmp (if not-p not-condition condition) target)))
 
-(define-vop (fast-char=/base-char base-char-compare)
+(define-vop (fast-char=/character character-compare)
   (:translate char=)
   (:variant :e :ne))
 
-(define-vop (fast-char</base-char base-char-compare)
+(define-vop (fast-char</character character-compare)
   (:translate char<)
   (:variant :b :nb))
 
-(define-vop (fast-char>/base-char base-char-compare)
+(define-vop (fast-char>/character character-compare)
   (:translate char>)
   (:variant :a :na))
 
-(define-vop (base-char-compare/c)
-  (:args (x :scs (base-char-reg base-char-stack)))
-  (:arg-types base-char (:constant base-char))
+(define-vop (character-compare/c)
+  (:args (x :scs (character-reg character-stack)))
+  (:arg-types character (:constant character))
   (:conditional)
   (:info target not-p y)
   (:policy :fast-safe)
@@ -151,14 +144,14 @@
     (inst cmp x (sb!xc:char-code y))
     (inst jmp (if not-p not-condition condition) target)))
 
-(define-vop (fast-char=/base-char/c base-char-compare/c)
+(define-vop (fast-char=/character/c character-compare/c)
   (:translate char=)
   (:variant :e :ne))
 
-(define-vop (fast-char</base-char/c base-char-compare/c)
+(define-vop (fast-char</character/c character-compare/c)
   (:translate char<)
   (:variant :b :nb))
 
-(define-vop (fast-char>/base-char/c base-char-compare/c)
+(define-vop (fast-char>/character/c character-compare/c)
   (:translate char>)
   (:variant :a :na))
diff -urN sbcl-0.8.16/src/compiler/x86/memory.lisp sbcl-0.8.16.patched/src/compiler/x86/memory.lisp
--- sbcl-0.8.16/src/compiler/x86/memory.lisp	2002-01-14 03:12:02.000000000 +0100
+++ sbcl-0.8.16.patched/src/compiler/x86/memory.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -116,7 +116,7 @@
 		    (make-ea :dword :base object
 			     :disp (- (* (+ base offset) n-word-bytes) lowtag))
 		    (logior (ash (char-code val) n-widetag-bits)
-			    base-char-widetag)))))
+			    character-widetag)))))
 	 ;; Else, value not immediate.
 	 (storew value object (+ base offset) lowtag))))
 
diff -urN sbcl-0.8.16/src/compiler/x86/move.lisp sbcl-0.8.16.patched/src/compiler/x86/move.lisp
--- sbcl-0.8.16/src/compiler/x86/move.lisp	2002-01-16 16:40:15.000000000 +0100
+++ sbcl-0.8.16.patched/src/compiler/x86/move.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -24,14 +24,14 @@
        (load-symbol y val))
       (character
        (inst mov y (logior (ash (char-code val) n-widetag-bits)
-			   base-char-widetag))))))
+			   character-widetag))))))
 
 (define-move-fun (load-number 1) (vop x y)
   ((immediate) (signed-reg unsigned-reg))
   (inst mov y (tn-value x)))
 
-(define-move-fun (load-base-char 1) (vop x y)
-  ((immediate) (base-char-reg))
+(define-move-fun (load-character 1) (vop x y)
+  ((immediate) (character-reg))
   (inst mov y (char-code (tn-value x))))
 
 (define-move-fun (load-system-area-pointer 1) (vop x y)
@@ -44,7 +44,7 @@
 
 (define-move-fun (load-stack 5) (vop x y)
   ((control-stack) (any-reg descriptor-reg)
-   (base-char-stack) (base-char-reg)
+   (character-stack) (character-reg)
    (sap-stack) (sap-reg)
    (signed-stack) (signed-reg)
    (unsigned-stack) (unsigned-reg))
@@ -52,7 +52,7 @@
 
 (define-move-fun (store-stack 5) (vop x y)
   ((any-reg descriptor-reg) (control-stack)
-   (base-char-reg) (base-char-stack)
+   (character-reg) (character-stack)
    (sap-reg) (sap-stack)
    (signed-reg) (signed-stack)
    (unsigned-reg) (unsigned-stack))
@@ -82,7 +82,7 @@
 	     (inst mov y (+ nil-value (static-symbol-offset val))))
 	    (character
 	     (inst mov y (logior (ash (char-code val) n-widetag-bits)
-				 base-char-widetag)))))
+				 character-widetag)))))
       (move y x))))
 
 (define-move-vop move :move
@@ -121,7 +121,7 @@
 	       (load-symbol y val))
 	      (character
 	       (inst mov y (logior (ash (char-code val) n-widetag-bits)
-				   base-char-widetag)))))
+				   character-widetag)))))
 	 (move y x)))
       ((control-stack)
        (if (sc-is x immediate)
@@ -136,7 +136,7 @@
 			    fp (tn-offset y)))
 		   (character
 		    (storew (logior (ash (char-code val) n-widetag-bits)
-				    base-char-widetag)
+				    character-widetag)
 			    fp (tn-offset y))))
 	       ;; Lisp stack
 	       (etypecase val
@@ -147,7 +147,7 @@
 			  fp (- (1+ (tn-offset y)))))
 		 (character
 		  (storew (logior (ash (char-code val) n-widetag-bits)
-				  base-char-widetag)
+				  character-widetag)
 			  fp (- (1+ (tn-offset y))))))))
 	 (if (= (tn-offset fp) esp-offset)
 	     ;; C-call
diff -urN sbcl-0.8.16/src/compiler/x86/pred.lisp sbcl-0.8.16.patched/src/compiler/x86/pred.lisp
--- sbcl-0.8.16/src/compiler/x86/pred.lisp	2001-10-11 00:44:31.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/x86/pred.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -50,7 +50,7 @@
 	   (inst cmp x (+ nil-value (static-symbol-offset val))))
 	  (character
 	   (inst cmp x (logior (ash (char-code val) n-widetag-bits)
-			       base-char-widetag))))))
+			       character-widetag))))))
      ((sc-is x immediate) ; and y not immediate
       ;; Swap the order to fit the compare instruction.
       (let ((val (tn-value x)))
@@ -63,7 +63,7 @@
 	   (inst cmp y (+ nil-value (static-symbol-offset val))))
 	  (character
 	   (inst cmp y (logior (ash (char-code val) n-widetag-bits)
-			       base-char-widetag))))))
+			       character-widetag))))))
       (t
        (inst cmp x y)))
 
diff -urN sbcl-0.8.16/src/compiler/x86/vm.lisp sbcl-0.8.16.patched/src/compiler/x86/vm.lisp
--- sbcl-0.8.16/src/compiler/x86/vm.lisp	2004-04-19 16:15:48.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/x86/vm.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -182,7 +182,7 @@
   ;; the non-descriptor stacks
   (signed-stack stack)			; (signed-byte 32)
   (unsigned-stack stack)		; (unsigned-byte 32)
-  (base-char-stack stack)		; non-descriptor characters.
+  (character-stack stack)		; non-descriptor characters.
   (sap-stack stack)			; System area pointers.
   (single-stack stack)			; single-floats
   (double-stack stack :element-size 2)	; double-floats.
@@ -228,12 +228,12 @@
 		  :alternate-scs (control-stack))
 
   ;; non-descriptor characters
-  (base-char-reg registers
-		 :locations #.*byte-regs*
-		 :reserve-locations (#.ah-offset #.al-offset)
+  (character-reg registers
+		 :locations #.*dword-regs*
+;		 :reserve-locations (#.ah-offset #.al-offset)
 		 :constant-scs (immediate)
 		 :save-p t
-		 :alternate-scs (base-char-stack))
+		 :alternate-scs (character-stack))
 
   ;; non-descriptor SAPs (arbitrary pointers into address space)
   (sap-reg registers
@@ -322,11 +322,12 @@
   (catch-block stack :element-size kludge-nondeterministic-catch-block-size))
 
 (eval-when (:compile-toplevel :load-toplevel :execute)
-(defparameter *byte-sc-names* '(base-char-reg byte-reg base-char-stack))
+(defparameter *byte-sc-names* '(byte-reg))
 (defparameter *word-sc-names* '(word-reg))
 (defparameter *dword-sc-names*
   '(any-reg descriptor-reg sap-reg signed-reg unsigned-reg control-stack
-    signed-stack unsigned-stack sap-stack single-stack constant))
+    signed-stack unsigned-stack sap-stack single-stack
+    character-reg character-stack constant))
 ;;; added by jrd. I guess the right thing to do is to treat floats
 ;;; as a separate size...
 ;;;
@@ -450,6 +451,10 @@
 ;;; The loader uses this to convert alien names to the form they need in
 ;;; the symbol table (for example, prepending an underscore).
 (defun extern-alien-name (name)
-  (declare (type simple-base-string name))
+  (declare (type string name))
   ;; ELF ports currently don't need any prefix
-  name)
+  (typecase name
+    (simple-base-string name)
+    (base-string (coerce name 'simple-base-string))
+    (t (handler-case (coerce name 'simple-base-string)
+	 (type-error () (error "invalid external alien name: ~S" name))))))
diff -urN sbcl-0.8.16/src/pcl/walk.lisp sbcl-0.8.16.patched/src/pcl/walk.lisp
--- sbcl-0.8.16/src/pcl/walk.lisp	2004-07-08 20:29:54.000000000 +0200
+++ sbcl-0.8.16.patched/src/pcl/walk.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -540,12 +540,8 @@
 (defun walk-template-handle-repeat (form template stop-form context env)
   (if (eq form stop-form)
       (walk-template form (cdr template) context env)
-      (walk-template-handle-repeat-1 form
-				     template
-				     (car template)
-				     stop-form
-				     context
-				     env)))
+      (walk-template-handle-repeat-1
+       form template (car template) stop-form context env)))
 
 (defun walk-template-handle-repeat-1 (form template repeat-template
 					   stop-form context env)
@@ -554,10 +550,10 @@
 	 (if (null repeat-template)
 	     (walk-template stop-form (cdr template) context env)
 	     (error "while handling code walker REPEAT:
-		     ~%ran into STOP while still in REPEAT template")))
+                     ~%ran into STOP while still in REPEAT template")))
 	((null repeat-template)
 	 (walk-template-handle-repeat-1
-	   form template (car template) stop-form context env))
+          form template (car template) stop-form context env))
 	(t
 	 (recons form
 		 (walk-template (car form) (car repeat-template) context env)
diff -urN sbcl-0.8.16/src/runtime/backtrace.c sbcl-0.8.16.patched/src/runtime/backtrace.c
--- sbcl-0.8.16/src/runtime/backtrace.c	2004-08-10 02:20:46.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/backtrace.c	2004-10-26 17:08:22.000000000 +0200
@@ -244,6 +244,7 @@
                         string = (struct vector *) object;
                         printf("%s, ", (char *) string->data);
                     } else
+			/* FIXME: broken from (VECTOR NIL) */
                         printf("(Not simple string??\?), ");
                 } else
                     printf("(Not other pointer??\?), ");
